//
//TD_DeMark_3_1_mod.mq4 
//Copyright  2005, Kara Software Corp. + modified SK 
//
#property copyright "Copyright  2005, Kara Software Corp."
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DeepSkyBlue
//---- input parameters
extern int       BackSteps=0;
extern int       ShowingSteps=1;
extern bool      FractalAsTD=false;
extern bool      Commen=true;
extern bool      TD=true;
extern bool      TrendLine=true;
extern bool      HorizontLine=true;
extern bool      TakeProf=true;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//
int init()
  {
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,217);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,218);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   for(int i=1;i<=10;i++)
     {
      ObjectDelete("Opn_B");ObjectDelete("HL");
      ObjectDelete("Opn_S");ObjectDelete("LL");
      ObjectDelete("Cls_B1");
      ObjectDelete("Cls_B2");
      ObjectDelete("Cls_B3");
      ObjectDelete("Cls_S1");
      ObjectDelete("Cls_S2");
      ObjectDelete("Cls_S3");
     }
   Comment("");
   return(0);
  }
//
int deinit()
  {
   for(int i=1;i<=10;i++)
     {
      ObjectDelete("Opn_B");ObjectDelete("HL");
      ObjectDelete("Opn_S");ObjectDelete("LL");
      ObjectDelete("Cls_B1");
      ObjectDelete("Cls_B2");
      ObjectDelete("Cls_B3");
      ObjectDelete("Cls_S1");
      ObjectDelete("Cls_S2");
      ObjectDelete("Cls_S3");
     }
   Comment("");
   return(0);
  }
//
int SetTDPoint(int B)
  {
   int shift;
   if (FractalAsTD==false)
     {
      for(shift=B;shift>1;shift--)
        {
         if (High[shift+1]<High[shift] && High[shift-1]<High[shift] && Close[shift+2]<High[shift])
            ExtMapBuffer1[shift]=High[shift];
         else ExtMapBuffer1[shift]=0;
         if (Low[shift+1]>Low[shift] && Low[shift-1]>Low[shift] && Close[shift+2]>Low[shift])
            ExtMapBuffer2[shift]=Low[shift];
         else ExtMapBuffer2[shift]=0;
        }
      ExtMapBuffer1[0]=0;
      ExtMapBuffer2[0]=0;
      ExtMapBuffer1[1]=0;
      ExtMapBuffer2[1]=0;
     }
   else
     {
      for(shift=B;shift>3;shift--)
        {
         if (High[shift+1]<=High[shift] && High[shift-1]<High[shift] && High[shift+2]<=High[shift] && High[shift-2]<High[shift])
            ExtMapBuffer1[shift]=High[shift];
         else ExtMapBuffer1[shift]=0;
         if (Low[shift+1]>=Low[shift] && Low[shift-1]>Low[shift] && Low[shift+2]>=Low[shift] && Low[shift-2]>Low[shift])
            ExtMapBuffer2[shift]=Low[shift];
         else ExtMapBuffer2[shift]=0;
        }
      ExtMapBuffer1[0]=0;
      ExtMapBuffer2[0]=0;
      ExtMapBuffer1[1]=0;
      ExtMapBuffer2[1]=0;
      ExtMapBuffer1[2]=0;
      ExtMapBuffer2[2]=0;
     }
   return(0);
  }
//
int GetHighTD(int P)
  {
   int i=0,j=0;
   while(j<P)
     {
      i++;
      while(ExtMapBuffer1[i]==0)
      {i++;if(i>Bars-2)return(-1);}
      j++;
     }
   return(i);
  }
//
int GetNextHighTD(int P)
  {
   int i=P+1;
   while(ExtMapBuffer1[i]<=High[P]){i++;if(i>Bars-2)return(-1);}
   return(i);
  }
//
int GetLowTD(int P)
  {
   int i=0,j=0;
   while(j<P)
     {
      i++;
      while(ExtMapBuffer2[i]==0)
      {i++;if(i>Bars-2)return(-1);}
      j++;
     }
   return(i);
  }
//
int GetNextLowTD(int P)
  {
   int i=P+1;
   while(ExtMapBuffer2[i]>=Low[P] || ExtMapBuffer2[i]==0){i++;if(i>Bars-2)return(-1);}
   return(i);
  }
//
int TrendLineHighTD(int H1,int H2,int Step,int Col)
  {
/*
   ObjectSet("HL",OBJPROP_TIME1,Time[H2]);ObjectSet("HL",OBJPROP_TIME2,Time[H1]);
   ObjectSet("HL",OBJPROP_PRICE1,High[H2]);ObjectSet("HL",OBJPROP_PRICE2,High[H1]);
   ObjectSet("HL",OBJPROP_COLOR,Col);
   if (Step==1)ObjectSet("HL",OBJPROP_WIDTH,2);
   else ObjectSet("HL",OBJPROP_WIDTH,1);
*/
   return(0);
  }
//
int TrendLineLowTD(int L1,int L2,int Step,int Col)
  {
/*
   ObjectSet("LL",OBJPROP_TIME1,Time[L2]);ObjectSet("LL",OBJPROP_TIME2,Time[L1]);
   ObjectSet("LL",OBJPROP_PRICE1,Low[L2]);ObjectSet("LL",OBJPROP_PRICE2,Low[L1]);
   ObjectSet("LL",OBJPROP_COLOR,Col);
   if (Step==1)ObjectSet("LL",OBJPROP_WIDTH,2);
   else ObjectSet("LL",OBJPROP_WIDTH,1);
*/
   return(0);
  }
//
int HorizontLineHighTD(int H1,int H2,int Step,double St,int Col)
  {
   string ObjName = "Opn_B";
   double Price = High[H2]-(High[H2]-High[H1])/(H2-H1)*H2;
   ObjectSet(ObjName,OBJPROP_PRICE1,Price);
   ObjectSet(ObjName,OBJPROP_PRICE2,Price);
   ObjectSet(ObjName,OBJPROP_TIME1, Time[0]+ 2*Period()*60);
   ObjectSet(ObjName,OBJPROP_TIME2, Time[0]-15*Period()*60);
   ObjectSet(ObjName,OBJPROP_WIDTH, 2);
   ObjectSet(ObjName,OBJPROP_RAY,   false);
   ObjectSet(ObjName,OBJPROP_STYLE, St);
   ObjectSet(ObjName,OBJPROP_COLOR, DodgerBlue);
   return(0);
  }
//
int HorizontLineLowTD(int L1,int L2,int Step,double St,int Col)
  {
   string ObjName = "Opn_S";
   double Price = Low[L2]+(Low[L1]-Low[L2])/(L2-L1)*L2;
   ObjectSet(ObjName,OBJPROP_PRICE1,Price);
   ObjectSet(ObjName,OBJPROP_PRICE2,Price);
   ObjectSet(ObjName,OBJPROP_TIME1, Time[0]+ 2*Period()*60);
   ObjectSet(ObjName,OBJPROP_TIME2, Time[0]-15*Period()*60);
   ObjectSet(ObjName,OBJPROP_WIDTH, 2);
   ObjectSet(ObjName,OBJPROP_RAY,   false);
   ObjectSet(ObjName,OBJPROP_STYLE, St);
   ObjectSet(ObjName,OBJPROP_COLOR, Red);
   return(0);
  }
//
string TakeProfitHighTD(int H1,int H2,int Step,int Col)
  {
   int i,ii,j=0;
   string Comm="";
   double kH,HC1,HC2,HC3,k,St;
   kH=(High[H2]-High[H1])/(H2-H1);
   while(NormalizeDouble(Point,j)==0)j++;
   k=0;
   for(i=H1;i>0;i--)if(Close[i]>High[H2]-kH*(H2-i)){k=High[H2]-kH*(H2-i);break;}
   if (k>0)
     {
      Comm=Comm+"UTD_Line ("+DoubleToStr(High[H2]-kH*H2,j)+")    "+DoubleToStr(k,j)+",  :\n";
      ii=Lowest(NULL,0,MODE_LOW,H2-i,i);
      HC1=High[H2]-kH*(H2-ii)-Low[ii];
      HC2=High[H2]-kH*(H2-ii)-Close[ii];
      ii=Lowest(NULL,0,MODE_CLOSE,H2-i,i);
      HC3=High[H2]-kH*(H2-ii)-Close[ii];
     }
   else
     {
      k=High[H2]-kH*H2;
      Comm=Comm+"UTD_Line ("+DoubleToStr(k,j)+"),     :\n";
      ii=Lowest(NULL,0,MODE_LOW,H2,0);
      HC1=High[H2]-kH*(H2-ii)-Low[ii];
      HC2=High[H2]-kH*(H2-ii)-Close[ii];
      ii=Lowest(NULL,0,MODE_CLOSE,H2,0);
      HC3=High[H2]-kH*(H2-ii)-Close[ii];
     }
   St=STYLE_DOT;
//   ObjectSet("HL",OBJPROP_STYLE,St);
   Comm=Comm+"1="+DoubleToStr(HC1+k,j)+" ("+DoubleToStr(HC1/Point,0)+".)";
   Comm=Comm+" 2="+DoubleToStr(HC2+k,j)+" ("+DoubleToStr(HC2/Point,0)+".)";
   Comm=Comm+" 3="+DoubleToStr(HC3+k,j)+" ("+DoubleToStr(HC3/Point,0)+".)\n";
   ObjectSet("Cls_B1",OBJPROP_TIME1,Time[H1]);ObjectSet("Cls_B1",OBJPROP_TIME2,Time[0]+10*Period()*60);
   ObjectSet("Cls_B1",OBJPROP_PRICE1,HC1+k);ObjectSet("Cls_B1",OBJPROP_PRICE2,HC1+k);
   ObjectSet("Cls_B1",OBJPROP_COLOR,Col);ObjectSet("Cls_B1",OBJPROP_STYLE,St);
   
   ObjectSet("Cls_B2",OBJPROP_TIME1,Time[H1]);ObjectSet("Cls_B2",OBJPROP_TIME2,Time[0]+10*Period()*60);
   ObjectSet("Cls_B2",OBJPROP_PRICE1,HC2+k);ObjectSet("Cls_B2",OBJPROP_PRICE2,HC2+k);
   ObjectSet("Cls_B2",OBJPROP_COLOR,Col);ObjectSet("Cls_B2",OBJPROP_STYLE,St);
   
   ObjectSet("Cls_B3",OBJPROP_TIME1,Time[H1]);ObjectSet("Cls_B3",OBJPROP_TIME2,Time[0]+10*Period()*60);
   ObjectSet("Cls_B3",OBJPROP_PRICE1,HC3+k);ObjectSet("Cls_B3",OBJPROP_PRICE2,HC3+k);
   ObjectSet("Cls_B3",OBJPROP_COLOR,Col);ObjectSet("Cls_B3",OBJPROP_STYLE,St);
/*
   if (Step==1)
     {
      ObjectSet("Cls_B1",OBJPROP_WIDTH,2);
      ObjectSet("Cls_B2",OBJPROP_WIDTH,2);
      ObjectSet("Cls_B3",OBJPROP_WIDTH,2);
     }
   else
     {
      ObjectSet("Cls_B1",OBJPROP_WIDTH,1);
      ObjectSet("Cls_B2",OBJPROP_WIDTH,1);
      ObjectSet("Cls_B3",OBJPROP_WIDTH,1);
     }
*/
   ObjectSet("Cls_B1",OBJPROP_RAY,   false);
   ObjectSet("Cls_B2",OBJPROP_RAY,   false);
   ObjectSet("Cls_B3",OBJPROP_RAY,   false);
   return(Comm);
  }
//
string TakeProfitLowTD(int L1,int L2,int Step,int Col)
  {
   int i,ii,j=0;
   string Comm="";
   double kL,LC1,LC2,LC3,k,St;
   kL=(Low[L1]-Low[L2])/(L2-L1);
   while(NormalizeDouble(Point,j)==0)j++;
   k=0;
   for(i=L1;i>0;i--)if(Close[i]<Low[L2]+kL*(L2-i)){k=Low[L2]+kL*(L2-i);break;}
   if (k>0)
     {
      Comm=Comm+"LTD_Line ("+DoubleToStr(Low[L2]+kL*L2,j)+")    "+DoubleToStr(k,j)+",  :\n";
      ii=Highest(NULL,0,MODE_HIGH,L2-i,i);
      LC1=High[ii]-(Low[L2]+kL*(L2-ii));
      LC2=Close[ii]-(Low[L2]+kL*(L2-ii));
      i=Highest(NULL,0,MODE_CLOSE,L2-i,i);
      LC3=Close[ii]-(Low[L2]+kL*(L2-ii));
     }
   else
     {
      k=Low[L2]+kL*L2;
      Comm=Comm+"LTD_Line ("+DoubleToStr(k,j)+"),     :\n";
      ii=Highest(NULL,0,MODE_HIGH,L2,0);
      LC1=High[ii]-(Low[L2]+kL*(L2-ii));
      LC2=Close[ii]-(Low[L2]+kL*(L2-ii));
      ii=Highest(NULL,0,MODE_CLOSE,L2,0);
      LC3=Close[ii]-(Low[L2]+kL*(L2-ii));
     }
   St=STYLE_DOT;
//   ObjectSet("LL",OBJPROP_STYLE,St);
   Comm=Comm+"1="+DoubleToStr(k-LC1,j)+" ("+DoubleToStr(LC1/Point,0)+".)";
   Comm=Comm+" 2="+DoubleToStr(k-LC2,j)+" ("+DoubleToStr(LC2/Point,0)+".)";
   Comm=Comm+" 3="+DoubleToStr(k-LC3,j)+" ("+DoubleToStr(LC3/Point,0)+".)\n";
   ObjectSet("Cls_S1",OBJPROP_TIME1,Time[L1]);ObjectSet("Cls_S1",OBJPROP_TIME2,Time[0]+10*Period()*60);
   ObjectSet("Cls_S1",OBJPROP_PRICE1,k-LC1);ObjectSet("Cls_S1",OBJPROP_PRICE2,k-LC1);
   ObjectSet("Cls_S1",OBJPROP_COLOR,Col);ObjectSet("Cls_S1",OBJPROP_STYLE,St);
   
   ObjectSet("Cls_S2",OBJPROP_TIME1,Time[L1]);ObjectSet("Cls_S2",OBJPROP_TIME2,Time[0]+10*Period()*60);
   ObjectSet("Cls_S2",OBJPROP_PRICE1,k-LC2);ObjectSet("Cls_S2",OBJPROP_PRICE2,k-LC2);
   ObjectSet("Cls_S2",OBJPROP_COLOR,Col);ObjectSet("Cls_S2",OBJPROP_STYLE,St);
   
   ObjectSet("Cls_S3",OBJPROP_TIME1,Time[L1]);ObjectSet("Cls_S3",OBJPROP_TIME2,Time[0]+10*Period()*60);
   ObjectSet("Cls_S3",OBJPROP_PRICE1,k-LC3);ObjectSet("Cls_S3",OBJPROP_PRICE2,k-LC3);
   ObjectSet("Cls_S3",OBJPROP_COLOR,Col);ObjectSet("Cls_S3",OBJPROP_STYLE,St);
/*
   if (Step==1)
     {
      ObjectSet("Cls_S1",OBJPROP_WIDTH,2);
      ObjectSet("Cls_S2",OBJPROP_WIDTH,2);
      ObjectSet("Cls_S3",OBJPROP_WIDTH,2);
     }
   else
     {
      ObjectSet("Cls_S1",OBJPROP_WIDTH,1);
      ObjectSet("Cls_S2",OBJPROP_WIDTH,1);
      ObjectSet("Cls_S3",OBJPROP_WIDTH,1);
     }
*/
   ObjectSet("Cls_S1",OBJPROP_RAY,   false);
   ObjectSet("Cls_S2",OBJPROP_RAY,   false);
   ObjectSet("Cls_S3",OBJPROP_RAY,   false);
   return(Comm);
  }
//
string TDMain(int Step)
  {
   int H1,H2,L1,L2;
   string Comm="---    "+Step+"   --------------------\n";
   int i,j; while(NormalizeDouble(Point,j)==0)j++;
   double Style;
/*
   double Col[20];Col[0]=Red;Col[2]=Magenta;Col[4]=Chocolate;Col[6]=Goldenrod;Col[8]=SlateBlue;
   Col[1]=DeepSkyBlue;Col[3]=DeepSkyBlue;Col[5]=Green;Col[7]=MediumOrchid;Col[9]=CornflowerBlue;
   Col[10]=Red;Col[12]=Magenta;Col[14]=Chocolate;Col[16]=Goldenrod;Col[18]=SlateBlue;
   Col[11]=DeepSkyBlue;Col[13]=DeepSkyBlue;Col[15]=Green;Col[17]=MediumOrchid;Col[19]=CornflowerBlue;
*/
   int Color_0 = DodgerBlue;
   int Color_1 = Red;
   Step=Step+BackSteps;
   H1=GetHighTD(Step);
   H2=GetNextHighTD(H1);
   L1=GetLowTD(Step);
   L2=GetNextLowTD(L1);
   if (H1<0)Comm=Comm+"UTD     TD  \n";
   else
      if (H2<0)Comm=Comm+"UTD    TD    ("+DoubleToStr(High[H1],j)+")\n";
      else Comm=Comm+"UTD "+DoubleToStr(High[H2],j)+"  "+DoubleToStr(High[H1],j)+"\n";
   if (L1<0)Comm=Comm+"LTD     TD  \n";
   else
      if (L2<0)Comm=Comm+"LTD    TD    ("+DoubleToStr(Low[L1],j)+")\n";
      else Comm=Comm+"LTD  "+DoubleToStr(Low[L2],j)+"  "+DoubleToStr(Low[L1],j)+"\n";
//----------------------------------------------------------------------------------  --
   if (Step==1)Style=STYLE_SOLID;
   else Style=STYLE_DOT;
   if (H1>0 && H2>0)
     {
      if (TrendLine==1)
        {
//         ObjectCreate("HL",OBJ_TREND,0,0,0,0,0);
         TrendLineHighTD(H1,H2,Step,Color_0);
        }
      else ObjectDelete("HL");
      if (HorizontLine==1 && Step==1)
        {
         ObjectCreate("Opn_B",OBJ_TREND,0,0,0,0,0);
         HorizontLineHighTD(H1,H2,Step,Style,Color_0);
        }
      else ObjectDelete("Opn_S");
      if (TakeProf==1)
        {
         ObjectCreate("Cls_B1",OBJ_TREND,0,0,0,0,0);
         ObjectCreate("Cls_B2",OBJ_TREND,0,0,0,0,0);
         ObjectCreate("Cls_B3",OBJ_TREND,0,0,0,0,0);
         Comm=Comm+TakeProfitHighTD(H1,H2,Step,Color_0);
        }
      else
        {
         ObjectDelete("Cls_B1");
         ObjectDelete("Cls_B2");
         ObjectDelete("Cls_B3");
        }
     }
//----------------------------------------------------------------------------------  --
   if (L1>0 && L2>0)
     {
      if (TrendLine==1)
        {
//         ObjectCreate("LL",OBJ_TREND,0,0,0,0,0);
         TrendLineLowTD(L1,L2,Step,Color_1);
        }
      else ObjectDelete("LL");
      if (HorizontLine==1 && Step==1)
        {
         ObjectCreate("Opn_S",OBJ_TREND,0,0,0,0,0);
         HorizontLineLowTD(L1,L2,Step,Style,Color_1);
        }
      else ObjectDelete("Opn_S");
      if (TakeProf==1)
        {
         ObjectCreate("Cls_S1",OBJ_TREND,0,0,0,0,0);
         ObjectCreate("Cls_S2",OBJ_TREND,0,0,0,0,0);
         ObjectCreate("Cls_S3",OBJ_TREND,0,0,0,0,0);
         Comm=Comm+TakeProfitLowTD(L1,L2,Step,Color_1);
        }
      else
        {
         ObjectDelete("Cls_S1");
         ObjectDelete("Cls_S2");
         ObjectDelete("Cls_S3");
        }
     }
   return(Comm);
  }
//
int start()
  {
   string Comm="";
   SetTDPoint(Bars-1);
   if (TD==1)
     {
      SetIndexArrow(0,217);
      SetIndexArrow(1,218);
     }
   else
     {
      SetIndexArrow(0,160);
      SetIndexArrow(1,160);
     }
   if (ShowingSteps>10)
     {
      Comment("ShowingSteps  0 - 10");
      return(0);
     }
   for(int i=1;i<=ShowingSteps;i++)Comm=Comm+TDMain(i);
   Comm=Comm+"------------------------------------\nShowingSteps="+ShowingSteps+"\nBackSteps="+BackSteps;
   if (FractalAsTD==true)Comm=Comm+"\nFractals";
   else Comm=Comm+"\nTD point";
   if (Commen==1)Comment(Comm);
   else Comment("");
   return(0);
  }
//

